Subject: Re: [Simple] MSRP (RFC 4975) question

From: Sebastian Dehne <[email-masked]>
Date: Wed, 18 Feb 2009 15:09:33 +0100

Hi,

One more thing: If the sender is currently busy transmitting a large 
chunk and receives a 413 while during so, should A) the sender expect 
another response for it's chunk (request) once he has sent the tail-line 
and thus completed/interrupted this chunk? Or B) will the already 
received 413 response count as a closure for the 'transaction'?

In case of B, the receiver must make sure to not send another response 
once it sees that an incoming chunk was ended in case it has already 
sent a response to it. In case of A, the receiver will always send a 
response as soon as it sees the end of a chunk, regardless if it had 
sent a 413 previously.

Thanks
Sebastian

On 01/06/2009 11:16 PM, Ben Campbell wrote:
> 
> 
> On Dec 29, 2008, at 10:09 AM, Paul Kyzivat wrote:
> 
>> I'm quite sure the intent was that the response may be sent for the 
>> chunk in progress.
>>
>>     Thanks,
>>     Paul
>>
> 
> Yes, that was definitely the intent. The "a chunk" in the quoted text 
> can certainly still be "the chunk".
> 
>> Gilad Govrin wrote:
>>> Hi,
>>> First of all thanks for the response.
>>> Actually I thought about this quote, but from this quote it is not clear
>>> whether the 413 received for the current chunk that is in sending
>>> process.
>>> Since it says: "while in the process of sending a chunk" and not "while
>>> in the process of sending the chunk".
>>> The situation may be sending chunk x and than sending chunk y
>>> (interruptible), then receive 413 for chunk x, in this case we must
>>> interrupt chunk y.
>>> Gilad
>>> -----Original Message-----
>>> From: Denis Bilenko [mailto:[email-masked]] Sent: Thursday, 
>>> December 25, 2008 10:29 AM
>>> To: Gilad Govrin
>>> Cc: [email-masked]
>>> Subject: Re: [Simple] MSRP (RFC 4975) question
>>> I think you don't have to wait for a complete chunk in order to send the
>>> response.
>>> Here's a quote from RFC that implies that:
>>>  If the sender receives the 413 while in the process of sending
>>>  a chunk, and the chunk is interruptible, the sender MUST interrupt it.
>>>  (http://tools.ietf.org/html/rfc4975#section-10.5)
>>> Gilad Govrin wrote:
>>>> Hi All,
>>>> Sorry for asking again but I didn't get any response for this one,
>>>> does anyone has insights about this one?
>>>> I need clarifications for issues raised while implementing RFC 4975
>>> MSRP.
>>>> In section 7.1.1 the RFC is "strongly recommended" to use
>>>> interruptible mechanism, meaning to send chunks greater than 2048 and
>>>> interrupt it when others are waiting to send their own messages on the
>>>> same connection, and as a result split large messages into fewer
>>>> chunks as possible.
>>>> Based on this fact, Theoretically, senders that implemented
>>>> interruptible mechanism can send 4GB file in one chunk (assuming no
>>>> one interrupt it while sending).
>>>> The receiver may detect that he don't want to process this message the
>>>> moment he gets the headers for example unsupported content type.
>>>> The question is whether the receiver is allow to send reject response
>>>> while receiving chunk data, or he should wait for the end-line and
>>>> only then send this response?
>>>> Thanks in advance,
>>>> Gilad
>>>>
>>>>
>>> ------------------------------------------------------------------------
>>>> _______________________________________________
>>>> Simple mailing list
>>>> [email-masked]
>>>> https://www.ietf.org/mailman/listinfo/simple
>>> _______________________________________________
>>> Simple mailing list
>>> [email-masked]
>>> https://www.ietf.org/mailman/listinfo/simple
>> _______________________________________________
>> Simple mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/simple
> 
> _______________________________________________
> Simple mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/simple
>

---

From: Sebastian Dehne <[email-masked]>
Date: Mon, 23 Feb 2009 13:49:05 +0100

Hi,

Could anyone please comment on this? Thank you.

kind regards,
Sebastian

---

From: "Rémi Denis-Courmont" <[email-masked]>
Date: Mon, 23 Feb 2009 15:03:06 +0200

Hello,

> received 413 response count as a closure for the 'transaction'?

Seriously, how could the answer be anything but B?

Say the receiver sends a response while the chunk is not completed on its end. 
How does it determine that the chunk will not be completed at the other end by 
the time the response reaches the sender? TCP/IP does not support faster-than-
light information conveyance in general and instantaneous transmission in 
particular.

Best regards,

-- 
Rémi Denis-Courmont

---

From: Sebastian Dehne <[email-masked]>
Date: Mon, 23 Feb 2009 15:20:13 +0100

Hi,

Thanks for the response. I agree that B is the only option.

Sebastian